unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,FPImage, LCLIntf;

type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure ShapeOnClick(Sender: TObject);
    procedure ScrollBarChange(Sender: TObject;ScrollCode: TScrollCode; var ScrollPos: LongInt);
  private
    Shape     : array [0..30] of TShape;
    ColCap    : array [0..30] of TStaticText;
    RGBCap    : array [0..30] of TStaticText;
    ScrollBar : TScrollBar;
    r,g,b     : byte;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var lv  : integer;
    FPcol : TFPColor;
    TCol  : TColor;

begin
  caption := 'System Colors';
  setbounds(30,50,1500,350);
  r:= 170;g:=170;b:=170;
  color:= rgb(r,g,b);

  for lv:=0 to 30 do
  begin
   Shape[lv]               := TShape.Create(self);
   Shape[lv].Parent        := self;
   Shape[lv].Width         := 100;
   Shape[lv].Height        :=  40;
   Shape[lv].Pen.Width     :=   3;
   Shape[lv].OnClick       := @ShapeOnClick;
   Shape[lv].Caption       := inttostr(lv);
   if lv < 11 then
    begin
     Shape[lv].Left          := 30+(lv*130);
     Shape[lv].Top           := 40;
    end;
   if (lv > 10) and (lv < 22) then
    begin
     Shape[lv].Left          := 30+((lv-11)*130);
     Shape[lv].Top           := 140;
    end;
   if (lv > 21) and (lv < 31) then
    begin
     Shape[lv].Left          := 30+((lv-22)*130);
     Shape[lv].Top           := 240;
    end;

   end;
   Shape[0].Brush.Color  := clScrollBar;
   Shape[1].Brush.Color  := clBackground;
   Shape[2].Brush.Color  := clActiveCaption;
   Shape[3].Brush.Color  := clInactiveCaption;
   Shape[4].Brush.Color  := clMenu;
   Shape[5].Brush.Color  := clWindow;
   Shape[6].Brush.Color  := clWindowFrame;
   Shape[7].Brush.Color  := clMenuText;
   Shape[8].Brush.Color  := clWindowText;
   Shape[9].Brush.Color  := clCaptionText;
   Shape[10].Brush.Color := clActiveBorder;
   Shape[11].Brush.Color := clInactiveBorder;
   Shape[12].Brush.Color := clAppWorkspace;
   Shape[13].Brush.Color := clHighlight;
   Shape[14].Brush.Color := clHighlightText;
   Shape[15].Brush.Color := clBtnFace;
   Shape[16].Brush.Color := clBtnShadow;
   Shape[17].Brush.Color := clGrayText;
   Shape[18].Brush.Color := clBtnText;
   Shape[19].Brush.Color := clInactiveCaptionText;
   Shape[20].Brush.Color := clBtnHighlight;
   Shape[21].Brush.Color := cl3DDkShadow;
   Shape[22].Brush.Color := cl3DLight;
   Shape[23].Brush.Color := clInfoText;
   Shape[24].Brush.Color := clInfoBk;
   Shape[25].Brush.Color := clHotLight;
   Shape[26].Brush.Color := clGradientActiveCaption;
   Shape[27].Brush.Color := clGradientInactiveCaption;
   Shape[28].Brush.Color := clMenuHighlight;
   Shape[29].Brush.Color := clMenuBar;
   Shape[30].Brush.Color := clForm;

   Shape[0].Pen.Color    := clScrollBar;
   Shape[1].Pen.Color  := clBackground;
   Shape[2].Pen.Color  := clActiveCaption;
   Shape[3].Pen.Color  := clInactiveCaption;
   Shape[4].Pen.Color  := clMenu;
   Shape[5].Pen.Color  := clWindow;
   Shape[6].Pen.Color  := clWindowFrame;
   Shape[7].Pen.Color  := clMenuText;
   Shape[8].Pen.Color  := clWindowText;
   Shape[9].Pen.Color  := clCaptionText;
   Shape[10].Pen.Color := clActiveBorder;
   Shape[11].Pen.Color := clInactiveBorder;
   Shape[12].Pen.Color := clAppWorkspace;
   Shape[13].Pen.Color := clHighlight;
   Shape[14].Pen.Color := clHighlightText;
   Shape[15].Pen.Color := clBtnFace;
   Shape[16].Pen.Color := clBtnShadow;
   Shape[17].Pen.Color := clGrayText;
   Shape[18].Pen.Color := clBtnText;
   Shape[19].Pen.Color := clInactiveCaptionText;
   Shape[20].Pen.Color := clBtnHighlight;
   Shape[21].Pen.Color := cl3DDkShadow;
   Shape[22].Pen.Color := cl3DLight;
   Shape[23].Pen.Color := clInfoText;
   Shape[24].Pen.Color := clInfoBk;
   Shape[25].Pen.Color := clHotLight;
   Shape[26].Pen.Color := clGradientActiveCaption;
   Shape[27].Pen.Color := clGradientInactiveCaption;
   Shape[28].Pen.Color := clMenuHighlight;
   Shape[29].Pen.Color := clMenuBar;
   Shape[30].Pen.Color := clForm;

 for lv:=0 to 30 do
  begin
   ColCap[lv]               := TStaticText.Create(self);
   ColCap[lv].Parent        := self;
   ColCap[lv].Width         := 120;
   ColCap[lv].Height        :=  20;
   if lv < 11 then
    begin
     ColCap[lv].Left          := 30+(lv*130);
     ColCap[lv].Top           := 20;
    end;
   if (lv > 10) and (lv < 22) then
    begin
     ColCap[lv].Left          := 30+((lv-11)*130);
     ColCap[lv].Top           := 120;
    end;
   if (lv > 21) and (lv < 31) then
    begin
     ColCap[lv].Left          := 30+((lv-22)*130);
     ColCap[lv].Top           := 220;
    end;
 end;
   ColCap[0].Caption  := 'clScrollBar';
   ColCap[1].Caption  := 'clBackground';
   ColCap[2].Caption  := 'clActiveCaption';
   ColCap[3].Caption  := 'clInactiveCaption';
   ColCap[4].Caption  := 'clMenu';
   ColCap[5].Caption  := 'clWindow';
   ColCap[6].Caption  := 'clWindowFrame';
   ColCap[7].Caption  := 'clMenuText';
   ColCap[8].Caption  := 'clWindowText';
   ColCap[9].Caption  := 'clCaptionText';
   ColCap[10].Caption := 'clActiveBorder';
   ColCap[11].Caption := 'clInactiveBorder';
   ColCap[12].Caption := 'clAppWorkspace';
   ColCap[13].Caption := 'clHighlight';
   ColCap[14].Caption := 'clHighlightText';
   ColCap[15].Caption := 'clBtnFace';
   ColCap[16].Caption := 'clBtnShadow';
   ColCap[17].Caption := 'clGrayText';
   ColCap[18].Caption := 'clBtnText';
   ColCap[19].Caption := 'clInactiveCaptionText';
   ColCap[20].Caption := 'clBtnHighlight';
   ColCap[21].Caption := 'cl3DDkShadow';
   ColCap[22].Caption := 'cl3DLight';
   ColCap[23].Caption := 'clInfoText';
   ColCap[24].Caption := 'clInfoBk';
   ColCap[25].Caption := 'clHotLight';
   ColCap[26].Caption := 'clGradientActiveCaption';
   ColCap[27].Caption := 'clGradientInactiveCaption';
   ColCap[28].Caption := 'clMenuHighlight';
   ColCap[29].Caption := 'clMenuBar';
   ColCap[30].Caption := 'clForm';

   ColCap[0].Font.Color    := clScrollBar;
   ColCap[1].Font.Color  := clBackground;
   ColCap[2].Font.Color  := clActiveCaption;
   ColCap[3].Font.Color  := clInactiveCaption;
   ColCap[4].Font.Color  := clMenu;
   ColCap[5].Font.Color  := clWindow;
   ColCap[6].Font.Color  := clWindowFrame;
   ColCap[7].Font.Color  := clMenuText;
   ColCap[8].Font.Color  := clWindowText;
   ColCap[9].Font.Color  := clCaptionText;
   ColCap[10].Font.Color := clActiveBorder;
   ColCap[11].Font.Color := clInactiveBorder;
   ColCap[12].Font.Color := clAppWorkspace;
   ColCap[13].Font.Color := clHighlight;
   ColCap[14].Font.Color := clHighlightText;
   ColCap[15].Font.Color := clBtnFace;
   ColCap[16].Font.Color := clBtnShadow;
   ColCap[17].Font.Color := clGrayText;
   ColCap[18].Font.Color := clBtnText;
   ColCap[19].Font.Color := clInactiveCaptionText;
   ColCap[20].Font.Color := clBtnHighlight;
   ColCap[21].Font.Color := cl3DDkShadow;
   ColCap[22].Font.Color := cl3DLight;
   ColCap[23].Font.Color := clInfoText;
   ColCap[24].Font.Color := clInfoBk;
   ColCap[25].Font.Color := clHotLight;
   ColCap[26].Font.Color := clGradientActiveCaption;
   ColCap[27].Font.Color := clGradientInactiveCaption;
   ColCap[28].Font.Color := clMenuHighlight;
   ColCap[29].Font.Color := clMenuBar;
   ColCap[30].Font.Color := clForm;

 for lv:=0 to 30 do
  begin
   RGBCap[lv]               := TStaticText.Create(self);
   RGBCap[lv].Parent        := self;
   RGBCap[lv].Width         := 120;
   RGBCap[lv].Height        :=  20;
   RGBCap[lv].Font.Color    := clBlue;
   if lv < 11 then
    begin
     RGBCap[lv].Left          := 30+(lv*130);
     RGBCap[lv].Top           := 90;
     FPcol:=TColorToFPColor(ColorToRGB(Shape[lv].Brush.Color));
     TCol:=FPColorToTColor(FPcol);
     RGBCap[lv].Caption:= 'RGB '+inttostr(Red(tcol))+'/'+inttostr(Green(tcol))+'/'+inttostr(Blue(tcol));
    end;
   if (lv > 10) and (lv < 22) then
    begin
     RGBCap[lv].Left          := 30+((lv-11)*130);
     RGBCap[lv].Top           := 190;
     FPcol:=TColorToFPColor(ColorToRGB(Shape[lv].Brush.Color));
     TCol:=FPColorToTColor(FPcol);
     RGBCap[lv].Caption:= 'RGB '+inttostr(Red(tcol))+'/'+inttostr(Green(tcol))+'/'+inttostr(Blue(tcol));
    end;
   if (lv > 21) and (lv < 31) then
    begin
     RGBCap[lv].Left          := 30+((lv-22)*130);
     RGBCap[lv].Top           := 290;
     FPcol:=TColorToFPColor(ColorToRGB(Shape[lv].Brush.Color));
     TCol:=FPColorToTColor(FPcol);
     RGBCap[lv].Caption:= 'RGB '+inttostr(Red(tcol))+'/'+inttostr(Green(tcol))+'/'+inttostr(Blue(tcol));
    end;
 end;

 ScrollBar                := TScrollBar.Create(self);
 ScrollBar.Parent         := self;
 ScrollBar.Kind           := sbVertical;
 ScrollBar.Min            :=  0;
 ScrollBar.Max            := 255;
 ScrollBar.Position       := 170;
 ScrollBar.SetBounds(1460,30,20,290);
 ScrollBar.OnScroll       := @ScrollBarChange;
 end;

procedure TForm1.ShapeOnClick(Sender: TObject);
var FPCol : TFPColor;
begin
  FPcol:=TColorToFPColor(ColorToRGB(Shape[strtoint((Sender as TShape).Caption)].Brush.Color));
  showmessage('RGB '+inttostr(FPCol.Red)+'/'+inttostr(FPCol.Green)+'/'+inttostr(FPCol.Blue));
end;

procedure TForm1.ScrollBarChange(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: LongInt);
begin
 r:= ScrollPos;g:=ScrollPos;b:=ScrollPos;
  color:=rgb(r,g,b);
end;



end.

